#   File:       "AEObject-Edition Sample".make
#   Target:     "AEObject-Edition Sample"
#  My Make File
# Very simple, the only change I made from the CreateMake script was
# getting rid of some libraries and adding the extra 
# dependency for my dumped headers
#
# COpts is used to set our C Options, change it to whatever you'd like.
# I usually use -w while I'm developing and debugging, then 
# -r -warnings on when I am ready to go final.
# I rarely use -warnings full, because our C compiler complains about losing bits too much  
COpts = -r -warnings on 


OBJECTS =   :obj:main.c.o 
			:obj:Menu.c.o 
			:obj:AppleEventCore.c.o 
			:obj:Subscribe.c.o 
			:obj:Publish.c.o 
			:obj:Files.c.o 
			:obj:Print.c.o 
			:obj:TextSections.c.o 
			:obj:Windows.c.o 
			:obj:globals.c.o 
			:obj:AEObject.c.o 
			:obj:AEUtilities.c.o 
			:obj:Utilities.c.o 
			:obj:Initialize.c.o 


"AEObject-Edition Sample"			"AEObject-Edition Sample".make AESamp.rsrc
	Rez  -append "AEObject-Edition Sample".r -o "AEObject-Edition Sample"



# I'm setting the object support library stuff to be preloaded, since it's  
# fragmenting my heap if I don't, since I call some of it before I've unloaded
# my initialization segment.  Just being extra memory-paranoid

# my link options are 
# -mf  use MultiFinder (process manager) memory if you can/need to
# -t APPL type appication
# -C CKD1  creator type

"AEObject-Edition Sample"  "AEObject-Edition Sample".make Sampheaders {OBJECTS} 
	Link -mf -t APPL -C CKD1   
		-ra AEObjSuppt=resPreload,resLocked 
		-ra AEObjGlue=resPreload,resLocked 
		-ra AEObjPacking=resPreload,resLocked 
		{OBJECTS} 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{libraries}"AEObjectSupportLib.o 
		-o "AEObject-Edition Sample"

Sampheaders   BuildHeaders.c SampConstants.h Structs.h prototypes.h Macros.h
	C  -c BuildHeaders.c 

:obj:main.c.o  "AEObject-Edition Sample".make  Structs.h main.c
	 C  {COpts}  main.c -o :obj:main.c.o
:obj:Menu.c.o  "AEObject-Edition Sample".make Structs.h  Menu.c
	 C  {COpts} Menu.c -o :obj:Menu.c.o

:obj:AppleEventCore.c.o  "AEObject-Edition Sample".make  Structs.h AppleEventCore.c
	 C  {COpts} AppleEventCore.c -o :obj:AppleEventCore.c.o
	 
:obj:Subscribe.c.o  "AEObject-Edition Sample".make  Structs.h Subscribe.c
	 C   {COpts} Subscribe.c -o :obj:Subscribe.c.o
	 
:obj:Publish.c.o  "AEObject-Edition Sample".make Structs.h  Publish.c
	 C  {COpts} Publish.c -o :obj:Publish.c.o
	 
:obj:Files.c.o  "AEObject-Edition Sample".make  Structs.h Files.c
	 C  {COpts} Files.c -o :obj:Files.c.o 
	 
:obj:Print.c.o  "AEObject-Edition Sample".make  Structs.h Print.c
	 C  {COpts} Print.c -o :obj:Print.c.o	 
:obj:TextSections.c.o  "AEObject-Edition Sample".make Structs.h  TextSections.c
	 C  {COpts} TextSections.c -o :obj:TextSections.c.o

:obj:Windows.c.o  "AEObject-Edition Sample".make Structs.h  Windows.c
	 C  {COpts} Windows.c -o :obj:Windows.c.o


:obj:globals.c.o  "AEObject-Edition Sample".make Structs.h  globals.c
	 C  {COpts} globals.c -o :obj:globals.c.o
:obj:AEObject.c.o  "AEObject-Edition Sample".make Structs.h  AEObject.c
	 C  {COpts} AEObject.c -o :obj:AEObject.c.o

:obj:AEUtilities.c.o  "AEObject-Edition Sample".make Structs.h  AEUtilities.c
	 C  {COpts} AEUtilities.c -o :obj:AEUtilities.c.o

:obj:Utilities.c.o  "AEObject-Edition Sample".make Structs.h  Utilities.c
	 C  {COpts} Utilities.c -o :obj:Utilities.c.o
:obj:Initialize.c.o  "AEObject-Edition Sample".make Structs.h  Initialize.c
	 C  {COpts} Initialize.c -o :obj:Initialize.c.o
