/*------------------------------------------------------------------------------
 *
 *	Apple Macintosh Developer Technical Support
 *
 *	Resource definitions
 *
 *	Program:	ProcDoggie
 *	File:		ProcDoggie.r - Rez Source
 *
 *	by:			Forrest Tanaka
 *
 *	Copyright  1988-1991 Apple Computer, Inc.
 *	All rights reserved.
 *
 *------------------------------------------------------------------------------
 *
 *	For the moment, the resource definitions are actually inside the ResEdit
 *	document called ProcDoggie.rsrc.  This file simply includes the resources
 *	in that file
 *
 *----------------------------------------------------------------------------*/

#include "SysTypes.r"
#include "Types.r"

type 'DITL' {
	integer = $$CountOf(DITLarray) - 1;
	wide array DITLarray {
		byte; /* Font index */
		byte textPlain=0,textBold=1,textItalic=2,textUnderline=4,textOutline=8,textShadow=16,textCondense=32,textExtend=64; /* Text item style */
		byte; /* Font size */
		byte justLeft=-2,justRight=-1,justDefault=0,justCenter=1; /* Justification */
		rect;											/* Item bounds			*/
				switch {

				case HelpItem:									/* Help Mgr type item */
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 1;					/* this is a new type = 1 */
						
						switch {
							case HMScanhdlg:
								byte = 4;						/* sizeola				*/
								key int = 1;					/* key value 			*/
								integer;						/* resource ID			*/
								
							case HMScanhrct:
								byte = 4;						/* sizeola				*/
								key int = 2;					/* key value 			*/
								integer;						/* resource ID			*/
								
							case HMScanAppendhdlg:
								byte = 6;						/* sizeola				*/
								key int = 8;					/* key value 			*/
								integer;						/* resource ID			*/
								integer;						/* offset (zero based)	*/
						};
				case Button:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 4;
						pstring;								/* Title				*/

				case CheckBox:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 5;
						pstring;								/* Title				*/

				case RadioButton:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 6;
						pstring;								/* Title				*/

				case Control:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 7;
						byte = 2;
						integer;								/* 'CTRL' ID			*/

				case StaticText:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 8;
						pstring;								/* Text 				*/

				case EditText:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 16;
						pstring;								/* Text 				*/

				case Icon:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 32;
						byte = 2;
						integer;								/* 'ICON' ID			*/

				case Picture:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 64;
						byte = 2;
						integer;								/* 'PICT' ID			*/

				case UserItem:
						boolean 		enabled,disabled;		/* Enable flag			*/
						key bitstring[7] = 0;
						byte = 0;
				};
				align word;
		};
};

include "ProcDoggie.rsrc";

resource 'DITL' (129, purgeable) {
	{	/* array DITLarray: 36 elements */
		/* [1] */
		0,
		0,
		0,
		0,
		{10, 10, 42, 42},
		UserItem {
			disabled
		},
		/* [2] */
		0,
		0,
		0,
		0,
		{10, 46, 30, 174},
		StaticText {
			disabled,
			"Process Name"
		},
		/* [3] */
		1,
		textBold,
		9,
		justDefault,
		{32, 46, 46, 144},
		StaticText {
			disabled,
			"Application"
		},
		/* [4] */
		1,
		textBold,
		9,
		justDefault,
		{19, 206, 33, 286},
		StaticText {
			disabled,
			"Total Size:"
		},
		/* [5] */
		1,
		textBold,
		9,
		justDefault,
		{32, 206, 46, 286},
		StaticText {
			disabled,
			"Free Memory:"
		},
		/* [6] */
		1,
		textPlain,
		9,
		justRight,
		{19, 285, 33, 325},
		StaticText {
			disabled,
			""
		},
		/* [7] */
		1,
		textPlain,
		9,
		justRight,
		{32, 285, 46, 325},
		StaticText {
			disabled,
			""
		},
		/* [8] */
		0,
		0,
		0,
		0,
		{10, 340, 42, 372},
		UserItem {
			disabled
		},
		/* [9] */
		0,
		0,
		0,
		0,
		{52, 10, 52, 372},
		UserItem {
			disabled
		},
		/* [10] */
		1,
		textBold,
		9,
		justDefault,
		{60, 10, 74, 62},
		StaticText {
			disabled,
			"Type:"
		},
		/* [11] */
		1,
		textBold,
		9,
		justDefault,
		{73, 10, 87, 62},
		StaticText {
			disabled,
			"Creator:"
		},
		/* [12] */
		2,
		textPlain,
		9,
		justDefault,
		{61, 61, 75, 136},
		StaticText {
			disabled,
			"TYPE"
		},
		/* [13] */
		2,
		textPlain,
		9,
		justDefault,
		{74, 61, 88, 136},
		StaticText {
			disabled,
			"CREA"
		},
		/* [14] */
		0,
		0,
		0,
		0,
		{92, 10, 92, 372},
		UserItem {
			disabled
		},
		/* [15] */
		1,
		textPlain,
		9,
		justDefault,
		{105, 48, 119, 62},
		StaticText {
			disabled,
			""
		},
		/* [16] */
		1,
		textPlain,
		9,
		justDefault,
		{118, 48, 132, 62},
		StaticText {
			disabled,
			""
		},
		/* [17] */
		1,
		textPlain,
		9,
		justDefault,
		{131, 48, 145, 62},
		StaticText {
			disabled,
			""
		},
		/* [18] */
		1,
		textPlain,
		9,
		justDefault,
		{144, 48, 158, 62},
		StaticText {
			disabled,
			""
		},
		/* [19] */
		1,
		textPlain,
		9,
		justDefault,
		{157, 48, 171, 62},
		StaticText {
			disabled,
			""
		},
		/* [20] */
		1,
		textPlain,
		9,
		justDefault,
		{170, 48, 184, 62},
		StaticText {
			disabled,
			""
		},
		/* [21] */
		1,
		textPlain,
		9,
		justDefault,
		{183, 48, 197, 62},
		StaticText {
			disabled,
			""
		},
		/* [22] */
		1,
		textPlain,
		9,
		justDefault,
		{196, 48, 210, 62},
		StaticText {
			disabled,
			""
		},
		/* [23] */
		1,
		textPlain,
		9,
		justDefault,
		{209, 48, 223, 62},
		StaticText {
			disabled,
			""
		},
		/* [24] */
		1,
		textPlain,
		9,
		justDefault,
		{222, 48, 236, 62},
		StaticText {
			disabled,
			""
		},
		/* [25] */
		1,
		textPlain,
		9,
		justDefault,
		{235, 48, 249, 62},
		StaticText {
			disabled,
			""
		},
		/* [26] */
		1,
		textBold,
		9,
		justDefault,
		{105, 61, 119, 341},
		StaticText {
			disabled,
			"Accepts suspend/resume events"
		},
		/* [27] */
		1,
		textBold,
		9,
		justDefault,
		{118, 61, 132, 341},
		StaticText {
			disabled,
			"Handles window activations on major switches"
		},
		/* [28] */
		1,
		textBold,
		9,
		justDefault,
		{131, 61, 145, 341},
		StaticText {
			disabled,
			"Reacts to mouse clicks that cause major "
			"switches"
		},
		/* [29] */
		1,
		textBold,
		9,
		justDefault,
		{144, 61, 158, 341},
		StaticText {
			disabled,
			"Accepts Application-Died events"
		},
		/* [30] */
		1,
		textBold,
		9,
		justDefault,
		{157, 61, 171, 341},
		StaticText {
			disabled,
			"Stationery-aware"
		},
		/* [31] */
		1,
		textBold,
		9,
		justDefault,
		{170, 61, 184, 341},
		StaticText {
			disabled,
			"Can work in background"
		},
		/* [32] */
		1,
		textBold,
		9,
		justDefault,
		{183, 61, 197, 341},
		StaticText {
			disabled,
			"Only works in background"
		},
		/* [33] */
		1,
		textBold,
		9,
		justDefault,
		{196, 61, 210, 341},
		StaticText {
			disabled,
			"High-level event aware"
		},
		/* [34] */
		1,
		textBold,
		9,
		justDefault,
		{209, 61, 223, 341},
		StaticText {
			disabled,
			"Accepts remote high-level events"
		},
		/* [35] */
		1,
		textBold,
		9,
		justDefault,
		{222, 61, 236, 341},
		StaticText {
			disabled,
			"Allows multi-user launches"
		},
		/* [36] */
		1,
		textBold,
		9,
		justDefault,
		{235, 61, 249, 341},
		StaticText {
			disabled,
			"32-bit clean"
		},
		/* [37] */
		1,
		textPlain,
		9,
		justLeft,
		{19, 325, 33, 335},
		StaticText {
			disabled,
			"K"
		},
		/* [7] */
		1,
		textPlain,
		9,
		justLeft,
		{32, 325, 46, 335},
		StaticText {
			disabled,
			"K"
		}
	}
};