UNIT UProcessLDEF;

{-------------------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	Data structures for process-list LDEF
#
#	Program:	ProcDoggie
#	File:		ProcessLDEF.p - Pascal Implementation
#
#	by:		Forrest Tanaka
#
#	Copyright  1988-1991 Apple Computer, Inc.
#	All rights reserved.
#
--------------------------------------------------------------------------------
#
#	This LDEF is a simple replacement for the standard LDEF.  The only advantange
#	this LDEF has over the standard LDEF is that it contains information specific
#	to processes that arent displayed.  This is to make identifying processes in
#	the Process List window easier.
#
#	Once the icon utilities are released to the developer community, this LDEF
#	will be updated to display the icon of each process in the list.
#
-------------------------------------------------------------------------------}
{[j=20/57/1$] Pasmat Options}
{$R-}


INTERFACE


(*******************************************************************************
* Used Units
*******************************************************************************)

	USES
		(* Group 1 *)
		 Types
		,QuickDraw

		(* Group 2 *)
		,Events
		,OSUtils
		,SegLoad
		,LowMem
		,TextEdit
		,ToolUtils

		(* Group 3 *)
		,Files
		,Lists
		,Processes
		,Script
		;


(*******************************************************************************
* Types
*******************************************************************************)

	TYPE
		ProcessListInfoRec = RECORD
			processName:    Str31;               {Processs name}
			serialNumber:   ProcessSerialNumber  {Processs serial number}
		END;
		ProcessListInfoPtr = ^ProcessListInfoRec;


{$S Main}
(*******************************************************************************
* ProcessList - Entry point to the List Definition Procedure
*
* This is the entry point to the custom list defproc used in ProcDoggie.  It
* isnt really intended to be called directly from any part of this application,
* Im just including it in the INTERFACE portion so that the linker has
* something to grab onto.
*******************************************************************************)

	PROCEDURE ProcessList (message:    Integer;
	                       selectCell: Boolean;
	                       cellRect:   Rect;
	                       theCell:    Cell;
	                       dataOffset: Integer;
	                       dataLength: Integer;
	                       theList:    ListHandle);


IMPLEMENTATION

	{$I UProcessLDEF.inc1.p}

END.
